﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.display.Bitmap;
    import flash.display.BitmapData;

	
	public class Fourmizer extends Sprite
	{
		
		private var quantity:Number = 90;
		private var dotNum:Number = 0
		private var dots:Array = [];
		private var vitesseMax:Number = 0.4;
		
		
		var blur:BlurFilter = new BlurFilter();
		//var filterArray:Array = new Array(blur);

		
		
		
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			for(var i:Number = 0;i<quantity;i++){
				addDot(Math.random()*stage.stageWidth,Math.random()*stage.stageHeight);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function addDot(x:Number,y:Number):void
		{
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = Math.random()*2*Math.PI;
			dots[dotNum].v = Math.random()*vitesseMax;
			dots[dotNum].s = new Sprite();
			dots[dotNum].s.graphics.beginFill(0xFF0079,0.6 * Math.random());
			dots[dotNum].s.graphics.lineStyle(20, 0xFF66FF, 0.1);
			dots[dotNum].s.graphics.drawCircle(1,1,60*Math.random());
			dots[dotNum].s.graphics.endFill();
			dots[dotNum].s.graphics.moveTo(mouseX, mouseY)
					
			
			addChild(dots[dotNum].s);
			dotNum++;
			
			blur.blurX = 1;
			blur.blurY = 1;
			blur.quality = 3;


			//dots[dotNum].s.filters = filterArray;
			
			
		}
		
		private function enterHandler(e:Event):void
		{
			movedot();
		}
		
		private function movedot():void
		{
			var i:Number,t:Number;
			var a:Number,s:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(i = 0;i<dotNum;i++){
				x = dots[i].x;
				y = dots[i].y;
				a = dots[i].angle;
				s = dots[i].v;
				vx = Math.cos(a)*s;
				vy = Math.sin(a)*s;
				x+=vx;
				y+=vy;
				if(x<3 || x>=stage.stageWidth-3 || y<3 ||y>=stage.stageHeight-3){
					if(x<3){
						x = 3
						vx*=-1;
					}
					if(x>stage.stageWidth-4){
						x = stage.stageWidth-4;
						vx*=-1;
					}
					if(y<3){
						y = 3;
						vy*=-1;
					}
					if(y>stage.stageHeight-4){
						y = stage.stageHeight-4;
						vy*=-1;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				//position
				dots[i].s.x = dots[i].x = x;
				dots[i].s.y = dots[i].y = y;
				if(Math.random()<.1){
					dots[i].angle+=Math.random()-.5;
				}
				if(Math.random()<.1){
					dots[i].v+=Math.random()-.5;
					dots[i].v = Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));
				}
			}
			
		}
	}
}